"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var graphql_subscriptions_1 = require("graphql-subscriptions");
var graphql_server_core_1 = require("graphql-server-core");
var rokot_mq_rabbit_1 = require("rokot-mq-rabbit");
var childLogger_1 = require("./childLogger");
var AMQPSubscriptionManager = (function (_super) {
    __extends(AMQPSubscriptionManager, _super);
    function AMQPSubscriptionManager(options) {
        var _this = _super.call(this, options) || this;
        _this.GRAPHQL_QUEUENAME = "graphql";
        var config = options.config || { host: "127.0.0.1", port: 5672 };
        var logger = options.logger;
        _this.logger = childLogger_1.createChildLogger(logger, 'AmqpSubscriptionManager');
        var factory = new rokot_mq_rabbit_1.RabbitMqConnectionFactory(logger, config);
        _this.dupSchema = options.schema;
        _this.listener = new rokot_mq_rabbit_1.RabbitMqConsumer(logger, factory);
        return _this;
    }
    AMQPSubscriptionManager.prototype.listenToQueries = function () {
        var _this = this;
        this.listener.subscribe(this.GRAPHQL_QUEUENAME, function (msg) { return _this.onMessage(msg); }).then();
    };
    AMQPSubscriptionManager.prototype.onMessage = function (message) {
        var options = JSON.parse(message);
        var params = {
            schema: this.dupSchema,
            query: options.query,
            variables: options.variables,
            context: options.context || {},
            rootValue: options.rootValue || {},
            operationName: options.operationName,
            logFunction: options.logFunction
        };
        graphql_server_core_1.runQuery(params);
    };
    return AMQPSubscriptionManager;
}(graphql_subscriptions_1.SubscriptionManager));
exports.AMQPSubscriptionManager = AMQPSubscriptionManager;
//# sourceMappingURL=SubscriptionManager.js.map